<template>
  <!-- This example requires Tailwind CSS v2.0+ -->
  <div class="flex">
    <div class="flex flex-col">
      <input id="input" type="text" />
      <div class="-my-2 overflow-x-auto sm:-mx-6 lg:mx-8">
        <div class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8">
          <div
            class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
          >
            <div class="users">
              <p>
                There are <strong>{{ users.length }}</strong> users so far
              </p>
              <p>
                Today <strong>{{ howManyUsersToday }}</strong> user(s) were
                created or modified
              </p>
              <p>
                Yesterday <strong>{{ howManyUsersYesterday }}</strong> user(s)
                were created or modified
              </p>
              <p>
                Last 7 days <strong>{{ howManyUsersWeek }}</strong> user(s) were
                created or modified, or an average of
                <strong>{{ Math.round(howManyUsersWeek / 7) }}</strong> per
                day
              </p>
              <p>
                Last 30 days <strong>{{ howManyUsersMonth }}</strong> user(s)
                were created or modified, or an average of
                <strong>{{ Math.round(howManyUsersMonth / 30) }}</strong> per
                day
              </p>
            </div>
            <table class="min-w-full divide-y-8 divide-yellow-200 divide-opacity-70">
              <thead class="bg-gray-50">
                <tr class="fix">
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  ></th>
                  <th
                    v-responsive.lg.xl.md
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Adacraft
                  </th>
                  <th
                    v-responsive.lg.xl.md
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Username
                  </th>
                  <th
                    v-responsive.lg.xl.md
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Id
                  </th>

                  <th
                    v-responsive.lg.xl.md
                    scope="col"
                    class="s-0 px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    About
                  </th>
                </tr>
              </thead>
              <tbody class="my-8 bg-white divide-y-8 divide-yellow-200 divide-opacity-70 border-8 border-light-black-500 border-opacity-50 border-rounded-lg">
                <tr v-for="user in users" v-bind:key="user.id" >
               
              
                  <td class="px-6 py-4 whitespace-nowrap">
                    <div class="flex items-center">
                      <div v-responsive.lg.xl class="flex-shrink-0 h-10 w-20">
                        <!-- 
                        Disable avatar for now. Because, for now, all image
                        files are downloaded for all users.
                        TODO renable it when a pagination is implmented
                         -->
                        <!-- <img
                          v-if="user.data.avatar"
                          class="h-10 w-10 rounded-full"
                          :src="user.data.avatar"
                          alt=""
                          width="150"
                          style="border-radius: 88888px"
                        /> -->
                      </div>
                      <div class="ml-4">
                        <div
                          v-if="user.data.user_metadata.full_name"
                          class="text-sm font-medium text-gray-900"
                        >
                          {{ user.data.user_metadata.full_name }}
                        </div>
                        <div v-else class="text-sm font-medium text-gray-500">
                          indifined
                        </div>
                        <div class="text-sm text-gray-500">
                          depuis
                          {{
                            new Date(user.ts / 1000).toLocaleDateString("fr-FR")
                          }}
                        </div>
                      </div>
                    </div>
                  </td>
                  <td class="px-6 py-4 whitespace-nowrap">
                    <a
                      v-bind:href="`https://adacraft.org/user/` + user.ref.id"
                      class="text-indigo-600 hover:text-indigo-900"
                      target="_blank"
                      ><img src="../assets/logo-adacraft.svg" alt="" width="30"
                    /></a>
                  </td>
                  <td class="py-4 whitespace-nowrap">
                    {{ user.data.username }}
                  </td>
                  <td v-responsive.lg.xl.md class="px-6 py-4 whitespace-nowrap">
                    <button
                      class="text-sm text-gray-900"
                      v-on:click="copyId(user.ref.id)"
                    >
                      {{ user.ref.id }}
                    </button>
                  </td>

                  <td
                    v-responsive.lg.xl.md
                    class="break-words w-1/3 px-6 py-4 text-sm text-gray-500 appearance-none"
                  >
                    {{
                      user.data.bio === undefined ?
                      'empty' :
                      (
                        (user.data.bio.length > 20) ?
                        user.data.bio.substring(0, 20) + '...' :
                        user.data.bio
                      )
                    }}
                  </td>
                </tr>
               
                

                <!-- More items... -->
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
   


<script>
import { faunasecret } from "../config.js";

var faunadb = require("faunadb");
const client = new faunadb.Client({
  secret: faunasecret,
});
const q = faunadb.query;
export default {
  name: "CardUser",
  data: function () {
    return {
      users: [],
    };
  },
  methods: {
    copyId(recupid) {
      console.log(recupid);

      let recupidnew = recupid;
      console.log(recupidnew);
      let nouveauInput = document.getElementById("input");
      nouveauInput.value = recupid;
      console.log(nouveauInput.value);
      nouveauInput.focus();
      nouveauInput.select();
      var successful = document.execCommand("copy");
      var msg = successful ? "successful" : "unsuccessful";
      console.log(successful, msg);
    },
  },

  mounted() {
    client
      .query(
        q.Map(
          q.Paginate(q.Match(q.Index("all_users")), { size: 5000 }),
          (ref) => q.Get(ref)
        )
      )
      .then((json) => {
        this.users = json.data.sort((a, b) => b.ts - a.ts);
        console.log(json.data, "test");
      })

      .catch((error) => error);
  },
  computed: {
    // Calculer combien de projets ont été créés aujourd'hui
    howManyUsersToday: function () {
      // La date du jour au format JJ-MM-AAAA
      const today = new Date().toLocaleDateString("fr-FR");
      // Tableau vide dans lequel on va mettre les projets correspondants à la date du jour
      let usersToday = [];
      // Boucle sur le tableau des projets
      this.users.forEach((user) => {
        // Pour chaque projet on convertit sa timestamp au format JJ-MM-AAAA
        const userDate = new Date(user.ts / 1000).toLocaleDateString("fr-FR");
        // Si la date du jour et celle de la création du projet sont égales
        if (userDate == today) {
          // On met le projet dans le tableau projectsToday
          usersToday.push(user);
        }
      });
      // On renvoie la taille du tableau (combien de projets il y a)
      return usersToday.length;
    },
    // Calculer combien de projets ont été créés hier
    howManyUsersYesterday: function () {
      // On instancie une nouvelle date à partir de la date du jour
      const yesterday = new Date();
      // On paramètre la date pour qu'elle enlève 1 jour à la date d'aujourd'hui
      yesterday.setDate(yesterday.getDate() - 1);
      // Tableau vide dans lequel on va mettre les projets correspondants
      let usersYesterday = [];
      // Boucle sur le tableau des projets
      this.users.forEach((user) => {
        // Pour chaque projet on convertit sa timestamp au format JJ-MM-AAAA
        const userDate = new Date(user.ts / 1000).toLocaleDateString("fr-FR");
        // Si la date d'hier' et celle de la création du projet sont égales
        if (userDate == yesterday.toLocaleDateString("fr-FR")) {
          // On met le projet dans le tableau projectsToday
          usersYesterday.push(user);
        }
      });
      // On renvoie la taille du tableau (combien de projets il y a)
      return usersYesterday.length;
    },
    // Calculer combien de projets ont été créés ou modifiés depuis 7 jours
    howManyUsersWeek: function () {
      // On instancie une nouvelle date à partir de la date du jour
      const past7days = new Date();
      // On paramètre la date pour qu'elle enlève 7 jours à la date d'aujourd'hui
      past7days.setDate(past7days.getDate() - 7);
      // Tableau vide dans lequel on va mettre les projets
      let usersPast7days = [];
      // Boucle sur le tableau des projets
      this.users.forEach((user) => {
        // Pour chaque projet on convertit sa timestamp au format ISO (YYYY-MM-DDTHH:mm:ss.sssZ )
        const userDate = new Date(user.ts / 1000).toISOString();
        // Si la date du projet est supérieure ou égale à celle d'il y a 7 jours
        if (userDate >= past7days.toISOString()) {
          // On met le projet dans le tableau projectsToday
          usersPast7days.push(user);
        }
      });
      // On renvoie la taille du tableau (combien de projets il y a)
      return usersPast7days.length;
    },
    howManyUsersMonth: function () {
      // On instancie une nouvelle date à partir de la date du jour
      const past30days = new Date();
      // On paramètre la date pour qu'elle enlève 1 mois à la date d'aujourd'hui
      past30days.setMonth(past30days.getMonth() - 1);
      // On définit l'horaire à OO:00
      past30days.setUTCHours(0, 0, 0, 0);
      // Tableau vide dans lequel on va mettre les projets
      let usersPast30days = [];
      // Boucle sur le tableau des projets
      this.users.forEach((user) => {
        // Pour chaque projet on convertit sa timestamp au format ISO (YYYY-MM-DDTHH:mm:ss.sssZ )
        const userDate = new Date(user.ts / 1000).toISOString();
        // Si la date du projet est plus grande ou égale à la date d'il y a 1 mois
        if (userDate >= past30days.toISOString()) {
          // On met le projet dans le tableau projectsToday
          usersPast30days.push(user);
        }
      });
      // On renvoie la taille du tableau (combien de projets il y a)
      return usersPast30days.length;
    },
  },
};
</script>

<style>
.card {
  margin: 10px;
}
.users {
  margin: 20px;
  text-align: center;
  color: rgb(41, 41, 41);
}
input {
  color: white;
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 1px;
}
input::selection {
  background-color: white;
}
.flex {
  display: flex;
}
</style>